import numpy as np
import cv2
import glob

#termination criteria
criteria = (cv2.TERM_CRITERIA_EPS + cv2.TERM_CRITERIA_MAX_ITER, 30, 0.001)

#prepare object points, like (0,0,0,), (1,0,0), (2,0,0)......, (6,6,0)
objp = np.zeros((6*6,3), np.float32)
objp[:,:2] = np.mgrid[0:6, 0:6].T.reshape(-1, 2)

#Arrays to store object points and image points from all the images.
objpoints = [] #3d points in real world
imgpoints = [] #2d points in image plane

images = glob.glob('*.JPG')
#print images
print ' '*8
for fname in images:
    img = cv2.imread(fname)
    #size = (int(img.get(cv2.cv.CV_CAP_PROP_FRAME_WIDTH)), int(img.get(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT)))
    print ' '
    print ' '
    print 'Type of image after reading', type(img)
    #print img.ndim
    #print img.size.width
    gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
    print 'Processing', fname

    ret = False
    #find chessboard corners
    ret, corners = cv2.findChessboardCorners(gray, (6, 6), None)
    #print 'Corners', corners
    #print ret

    #If found, add object points, image points (after refining them)
    if ret == True:
        print 'Corners found in', fname
        objpoints.append(objp)

        cv2.cornerSubPix(gray, corners, (11, 11), (-1, -1), criteria)
        print 'Corners2', corners
        imgpoints.append(corners)

        #Draw and display the corners
        cv2.drawChessboardCorners(img, (6, 6), corners, ret)
        print 'Type of img after drawChessboardCorners', type(img)
        #cv2.imshow('img', img)
        #cv2.waitKey(500)
    else:
        print 'Corners not found in', fname

ret, mtx, dist, rvecs, tvecs = cv2.calibrateCamera(objpoints, imgpoints, gray.shape[::-1],None,None)
cv2.destroyAllWindows()

img2 = cv2.imread('input.JPG')
h,  w = img2.shape[:2]
newcameramtx, roi=cv2.getOptimalNewCameraMatrix(mtx,dist,(w,h),1,(w,h))

# undistort
dst = cv2.undistort(img2, mtx, dist, None, newcameramtx)

# crop the image
x,y,w,h = roi
dst[y:y+h, x:x+w]

cv2.imshow('Calibrated', dst)
k = cv2.waitKey(0) & 0xFF
if k == 27:     # Press ESC to end
    cv2.destroyAllWindows()

cv2.imwrite('zcalibrated.png',dst)

