import cv2
from numpy import *
from matplotlib import pyplot as plt
import scipy.misc as sc
import math

flowvis = cv2.imread('hub.png')

mask = zeros(flowvis.shape, dtype=uint8)
roi_corners = array([[(30,195),(30,1925),(4090,1925),(1580,195)]], dtype=int32)
# fill the ROI so it doesn't get wiped out when the mask is applied
channel_count = flowvis.shape[2]  # i.e. 3 or 4 depending on your image
ignore_mask_color = (255,)*channel_count
cv2.fillPoly(mask, roi_corners, ignore_mask_color)
# apply the mask
masked = cv2.bitwise_and(flowvis, mask)

gray = cv2.cvtColor(masked,cv2.COLOR_BGR2GRAY)

blur1 = cv2.medianBlur(gray,45)
blur2 = cv2.GaussianBlur(blur1,(13,13),0)

# To get the maximum shear location: ret,thresh = cv2.threshold(blur1,25,255,0)

ret,thresh = cv2.threshold(blur2,145,145,0)

contours, hierarchy = cv2.findContours(thresh,cv2.RETR_TREE,cv2.CHAIN_APPROX_SIMPLE)

img = cv2.drawContours(masked,contours,-1,(0,0,0),5)

masked2 = masked/2

maskedHSV = (cv2.cvtColor(masked2,cv2.COLOR_BGR2HSV))

screen_res = 1496., 1000.
scale_width = screen_res[0] / masked.shape[1]
scale_height = screen_res[1] / masked.shape[0]
scale = min(scale_width, scale_height)
window_width = int(masked.shape[1] * scale)
window_height = int(masked.shape[0] * scale)

# create a named window object
cv2.namedWindow('Image1', cv2.WINDOW_NORMAL)
cv2.resizeWindow('Image1', window_width, window_height)

cv2.imshow('Image1',maskedHSV)
k = cv2.waitKey(0) & 0xFF
if k == 27:     # Press ESC to end
    cv2.destroyAllWindows()

cv2.imwrite('Maxiumum_Wall_Shear_Point_Hub.png',maskedHSV)
