import cv2
from numpy import *
from matplotlib import pyplot as plt
import scipy.misc as sc
import math

flowvis = cv2.imread('casing.png')

mask = zeros(flowvis.shape, dtype=uint8)
roi_corners = array([[(30,195),(30,1925),(4090,1925),(1580,195)]], dtype=int32)
# fill the ROI so it doesn't get wiped out when the mask is applied
channel_count = flowvis.shape[2]  # i.e. 3 or 4 depending on your image
ignore_mask_color = (255,)*channel_count
cv2.fillPoly(mask, roi_corners, ignore_mask_color)
# apply the mask
masked = cv2.bitwise_and(flowvis, mask)

gray = cv2.cvtColor(masked,cv2.COLOR_BGR2GRAY)


blur1 = cv2.medianBlur(gray,15)
#blur2 = cv2.GaussianBlur(blur1,(9,9),0)

# To get the maximum shear location: ret,thresh = cv2.threshold(blur1,25,255,0)

ret,thresh = cv2.threshold(blur1,0,255,0) # SET A LOWER LIMIT FOR CONTOURS

contours, hierarchy = cv2.findContours(thresh,cv2.RETR_TREE,cv2.CHAIN_APPROX_SIMPLE)

img = cv2.drawContours(masked,contours,-1,(0,0,0),2)

cnt = contours[0]
M = cv2.moments(cnt)

cx = int(M['m10']/M['m00'])
cy = int(M['m01']/M['m00'])
area = cv2.contourArea(cnt)

mask2 = zeros(gray.shape,uint8)
cv2.drawContours(mask2,[cnt],0,255,-1)
pixelpoints = transpose(nonzero(mask2))
#pixelpoints = cv2.findNonZero(mask)

min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(blur1,mask = mask2)

#print ('Cx =',cx,'Cy =',cy,'Area =', area)

print  'Maximum Value =',max_val,'Location =',max_loc

cv2.imwrite('Max Shear Point.jpg',masked)
